# Circle Agent #
VM kontextualizálását végzi

## Linux ##
 * virtualenv-ben fut szervizként
 * Fájlok
   - /root/agent/*
   - /usr/bin/vm_renewal
   - /etc/systemd/system/agent.service

### tesztelve ***
   - ubuntu 18.04, 20.04, 22.04, 24.04
   - vannak más és régebbi rednszerekhez is alkatrészek a repóban, de feledésbe merültek...

### Linux install ###
 * Feltételezzuk, hogy van python3 és virtualenv, ha nincs:
   - sudo apt install python3
   - sudp apt install virtualenvwrapper
 * sudo -i  
 * cd /root
 * chmod oug+x .
 * mkvirtualenv agent
 * workon agent
 * git clone https://git.ik.bme.hu/CIRCLE3/agent.git
 * chmod oug+rx agent
 * cd agent
 * python agent.py --install
   - bemasolja az agent.service-t  /etc/systemd -be, engedélyezi, de nem indítja el
   - bemasolja a vm_renewal-t a /usr/bin/ -be 

## Windows ##
 * Bundled python alkalmazások, melyekből az első kettő szervízként fut, a harmadik a clud user belépésekor indul
 * Fájlok:
   - c:\circle\agent-winservice.exe 
   - c:\circle\agemt-wdog-winservice.exe 
   - c:\circle\agent-notify.exe 

### tesztelve ***
   - windows 10, 11
   - Win7-re az ez a verzió nem megy fel. Régit kell hazsnálni. 
 
### Windows install ###
 * Adminisztrátori jogokkali:
 * Létre kell hozni egy ```c:\circle``` katalógust
 * Ebbe le kell tölteni a https://git.ik.bme.hu/CIRCLE3/agent/tree/master/win_exe/w10 vagy w11 katalógus fájljait. Célszerű az ```sdelete64```-et és a ```wget```-et is letölteni, de nem szükséges. Majd: 
  ```
   cd:\circle
   .\agent-winservice.exe --startup auto install
   .\agent-wdog-winservice --startup auto install
   .\agent-winservice.exe start
   .\agent-wdog-winservice start
  ```
 * Ha a fentiek sikerültek, akkor be kell konfuigurálni, hogy a circle_notify.exe automatikusan elinduljon amikor a cloud user belép. Ez 11-ben kicsit trükkös:
   - windows-R (run command): ```shell:starup```
   - erre megnyilik egy foldernek látszó ablak, amibe be kell húzni (link kell!) a ˙˙`circle-notify.exe```-t 

## Egyebek ##

### USER ###
 * cloud 

### hálózat ###
 *  ubuntu alatt a ```/etc/network/interfaces``` fájlt piszkálja

### DNS ###
 * Linux alatt még a ```resolv.conf```-ot piszkálja **TODO**
 
#### SMBFS ####
  * mindenhol case insensitive, kiveve a /etc/nsmb.conf-ban es a ~/.nsmbrc-ben, itt a userneveket szigoruan upper-case kell irni
  * az /etc/nsmb.conf-ban vagy a ~/.nsmbrc-ben meg kell ismetelni a [SERVER] es a [SERVER:USER] reszeknel az add-t es a password-ot

#### SERIAL ####
  * virtios soros port elsodlegesen, utana hw soros
    - windows alatt csak virtio-val tesztelve
  * \r sorveg eseten hibas csomagok, FreeBSD-n \n az elvart

